import '../style.scss';
import '../editor.scss';
import { Fragment } from '@wordpress/element';

const { __ } = wp.i18n;

const {
	registerFormatType,
	applyFormat,
} = wp.richText;

const {
	InspectorControls,
} = wp.editor;

const {
	PanelBody,
	BaseControl,
	Button,
} = wp.components;

const insertIcon = 'keni-icon/keni-icon';
// eslint-disable-next-line no-undef
const { times } = lodash;
registerFormatType( insertIcon, {
	settings: 'html',
	title: __( 'Icon', 'keni' ),
	tagName: 'i',
	className: 'icon',
	attributes: {
		class: 'class',
	},
	edit: ( props ) => {
		const {
			value,
			onChange,
		} = props;
		const icons = [
			{
				value: 'icon_point',
			},
			{
				value: 'icon_caution',
			},
			{
				value: 'icon_blank',
			},
			{
				value: 'icon_arrow_up',
			},
			{
				value: 'icon_arrow_right',
			},
			{
				value: 'icon_arrow_down',
			},
			{
				value: 'icon_arrow_left',
			},
			{
				value: 'icon_download',
			},
			{
				value: 'icon_pdf',
			},
			{
				value: 'icon_zip',
			},
			{
				value: 'icon_mail',
			},
			{
				value: 'icon_cart',
			},
			{
				value: 'icon_search',
			},
			{
				value: 'icon_home',
			},
			{
				value: 'icon_folder',
			},
			{
				value: 'icon_time',
			},
			{
				value: 'icon_calendar',
			},
			{
				value: 'icon_building',
			},
			{
				value: 'icon_map',
			},
			{
				value: 'icon_new',
			},
			{
				value: 'icon_beginner',
			},
			{
				value: 'icon_share',
			},
			{
				value: 'icon_tel',
			},
		];
		return (
			<Fragment>
				<InspectorControls>
					<PanelBody title="アイコン">
						<BaseControl>
							<div className="keni-icon-list">
								{ times( icons.length, ( index ) => {
									return (
										<Button
											className={ `${ icons[ index ].value }` }
											onClick={ () => {
												const insertIconValue = ' ';
												props.value.text = insertStr( value.text, value.start, insertIconValue );
												props.value.end = props.value.text.length;
												props.className = icons[ index ].value;
												// onChange(
												// join( props.value, { type: insertIcon }, textEnd, props.value.text.length ),
												// 	applyFormat( props.value, { type: insertIcon }, textEnd, props.value.text.length ),
												// );
												onChange(
													applyFormat( value, {
														type: insertIcon,
														attributes: {
															class: `${ icons[ index ].value }`,
														},
													}
													) );
											} }
										>
										</Button>
									);
								} ) }
							</div>
						</BaseControl>
					</PanelBody>
				</InspectorControls>
			</Fragment>
		);
	},
} );

function insertStr( str, indexNum, value ) {
	const res = str.slice( 0, indexNum ) + value + str.slice( indexNum );
	return res;
}
