<?php
//-----------------------------------------------------
// 基本設定 - 投稿
//-----------------------------------------------------
/**
 * add menu
 */
function keni_admin_post() {
	add_submenu_page( 'keni_admin_menu', __( 'Keni Settings post', 'keni' ), __( 'Keni Settings post', 'keni' ), 'administrator', 'keni_admin_menu_posts', 'keni_setting_page_posts' );
	add_action( 'admin_init', 'keni_register_post', 'admin-head' );
}

add_action( 'admin_menu', 'keni_admin_post' );

/**
 * 初期値
 */
function keni_default_post() {
	$flag_get_relation_disp = get_option( 'keni_relation_disp' );
	if ( empty( $flag_get_relation_disp ) ) {
		add_option( 'keni_relation_disp', "show" );
	}
	$flag_category_relation = get_option( 'keni_category_relation' );
	if ( empty( $flag_category_relation ) ) {
		add_option( 'keni_category_relation', "1" );
	}
	$flag_get_relation_style = get_option( 'keni_relation_style' );
	if ( empty( $flag_get_relation_style ) ) {
		add_option( 'keni_relation_style', '1' );
	}
	$flag_get_thumbnail_disp = get_option( 'keni_thumbnail_disp' );
	if ( empty( $flag_get_thumbnail_disp ) ) {
		add_option( 'keni_thumbnail_disp', "show" );
	}
	$flag_get_toc_disp = get_option( 'keni_toc_disp' );
	if ( empty( $flag_get_toc_disp ) ) {
		add_option( 'keni_toc_disp', "hide" );
	}
}

add_action( 'init', 'keni_default_post' );

add_filter( 'the_password_form', 'keni_password_form', 10, 1 );
add_filter( 'protected_title_format', 'keni_password_title_format', 10, 1 );


/**
 * Register
 */
function keni_register_post() {
	register_setting( 'keni-initialize-setting_page_post', 'keni_author_disp' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_time_disp' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_single_after_contents' );

	// Relation post Default
	if ( ! empty( $_POST['keni_relation_disp'] ) && $_POST['keni_relation_disp'] == '1' && empty( $_POST['keni_category_relation'] ) && empty( $_POST['keni_tag_relation'] ) ) {
		$_POST['keni_category_relation'] = '1';
	}
	register_setting( 'keni-initialize-setting_page_post', 'keni_relation_disp' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_relation_style' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_category_relation' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_tag_relation' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_thumbnail_disp' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_toc_disp' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_toc_title' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_toc_cut_h' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_toc_close_flg' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_home_link_name' );
	register_setting( 'keni-initialize-setting_page_post', 'keni_home_string' );
}

function keni_setting_page_posts() {

	$str_option_group = 'keni-initialize-setting_page_post';

	/* set 共通設定 */
	# author disp
	$flag_get_author_disp = get_option( 'keni_author_disp', '' );
	$arr_list_author_disp = array(
		array( "", __( 'Not Display', 'keni' ) ),
		array( "1", __( 'Display', 'keni' ) ),
	);
	$str_html_author_disp = keni_format_radio( 'keni_author_disp', $flag_get_author_disp, $arr_list_author_disp );

	# time disp
	$flag_get_time_disp = get_option( 'keni_time_disp', 'show' );
	$arr_list_time_disp = array(
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display Post Date & Update Date', 'keni' ) ),
		array( "update", __( 'Display Update Date', 'keni' ) ),
		array( "post", __( 'Display Post Date', 'keni' ) ),
	);
	$str_html_time_disp = keni_format_radio( 'keni_time_disp', $flag_get_time_disp, $arr_list_time_disp );

	# Single after contents
	$str_get_single_after_contents  = get_option( 'keni_single_after_contents' );
	$str_html_single_after_contents = keni_format_textarea( 'keni_single_after_contents', $str_get_single_after_contents, 'large-text' );


	# Relation 全体設定
	$flag_get_relation_disp = get_option( 'keni_relation_disp' );
	$arr_list_relation_disp = array(
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);
	$str_html_relation      = keni_format_radio( 'keni_relation_disp', $flag_get_relation_disp, $arr_list_relation_disp );

	$flag_category_relation     = get_option( 'keni_category_relation' );
	$arr_list_category_relation = array(
		array( "1", __( 'Category', 'keni' ) ),
	);
	$str_html_category_relation = keni_format_checkbox( 'keni_category_relation', $flag_category_relation, $arr_list_category_relation, true );

	$flag_tag_relation     = get_option( 'keni_tag_relation' );
	$arr_list_tag_relation = array(
		array( "1", __( 'Tag', 'keni' ) ),
	);
	$str_html_tag_relation = keni_format_checkbox( 'keni_tag_relation', $flag_tag_relation, $arr_list_tag_relation, true );

	$flag_get_relation_style = get_option( 'keni_relation_style' );
	$arr_list_relation_style = array(
		array( "1", __( 'List Style', 'keni' ) ),
		array( "2", __( 'Card Style', 'keni' ) ),
	);
	$str_html_relation_style = keni_format_radio( 'keni_relation_style', $flag_get_relation_style, $arr_list_relation_style );

	# アイキャッチ画像設定
	$flag_get_thumbnail_disp = get_option( 'keni_thumbnail_disp' );
	$arr_list_thumbnail_disp = array(
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);
	$str_html_thumbnail_disp = keni_format_radio( 'keni_thumbnail_disp', $flag_get_thumbnail_disp, $arr_list_thumbnail_disp );

	# 全体の目次表示設定
	$flag_get_toc_disp = get_option( 'keni_toc_disp' );
	$arr_list_toc_disp = array(
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);
	$str_html_toc_disp = keni_format_radio( 'keni_toc_disp', $flag_get_toc_disp, $arr_list_toc_disp );

	$str_toc_title           = esc_attr( get_option( 'keni_toc_title', '' ) );
	$str_html_toc_disp_title = keni_format_text( 'keni_toc_title', $str_toc_title, 'large-text' );

	$cut_h_list         = array(
		array( '0', __( 'Display All', 'keni' ) ),
		array( '3', __( 'Display until h2', 'keni' ) ),
		array( '4', __( 'Display until h3', 'keni' ) ),
		array( '5', __( 'Display until h4', 'keni' ) )
	);
	$str_toc_cut_h      = get_option( 'keni_toc_cut_h', '0' );
	$str_html_toc_cut_h = keni_format_select( 'keni_toc_cut_h', $str_toc_cut_h, $cut_h_list );

	$open_status_list       = array( array( '0', __( 'OPEN', 'keni' ) ), array( '1', __( 'CLOSE', 'keni' ) ) );
	$str_toc_close_flg      = get_option( 'keni_toc_close_flg', '0' );
	$str_html_toc_close_flg = keni_format_radio( 'keni_toc_close_flg', $str_toc_close_flg, $open_status_list );

	$keni_home_link_name     = get_option( 'keni_home_link_name', '' );
	$keni_home_string        = get_option( 'keni_home_string', '' );
	$str_keni_home_link_name = keni_format_text( 'keni_home_link_name', $keni_home_link_name, 'large-text' );
	$str_keni_home_string    = keni_format_text( 'keni_home_string', $keni_home_string, 'large-text' );

	$arr_metaboxs[] = sprintf( keni_format_author_disp(), $str_html_author_disp );
	$arr_metaboxs[] = sprintf( keni_format_time_disp(), $str_html_time_disp );
	$arr_metaboxs[] = sprintf( keni_format_single_after_contents(), $str_html_single_after_contents );
	$arr_metaboxs[] = sprintf( keni_format_relation(), $str_html_relation, $str_html_category_relation, $str_html_tag_relation, $str_html_relation_style );
	$arr_metaboxs[] = sprintf( keni_format_thumbnail_disp(), $str_html_thumbnail_disp );
	$arr_metaboxs[] = sprintf( keni_format_toc_disp(), $str_html_toc_disp, $str_html_toc_disp_title, $str_html_toc_cut_h, $str_html_toc_close_flg );
	$arr_metaboxs[] = sprintf( keni_format_home_name(), $str_keni_home_link_name, $str_keni_home_string );

	keni_the_format_options_form( $str_option_group, $arr_metaboxs );
}


/**
 * Format canonical
 * @return string html
 */
function keni_format_setting_post_common() {
	$title = __( 'Common Settings', 'keni' );
	$main  = '<p class="post-attributes-label-wrapper"><label class="post-attributes-label">' . __( '投稿者情報の表示', 'keni' ) . '</label></p>
	        %s
	        <p class="post-attributes-label-wrapper"><label class="post-attributes-label">' . __( '更新時間・投稿時間の表示', 'keni' ) . '</label></p>
	        %s
	        <p class="post-attributes-label-wrapper"><label class="post-attributes-label">' . __( '記事下のコンテンツ', 'keni' ) . '</label></p>
	        %s
	        <p class="post-attributes-label-wrapper"><label class="post-attributes-label">' . __( '全体の関連記事設定', 'keni' ) . '</label></p>
	        %s
	        <div style="padding-left: 2em;">
	        %s
	        %s
	        </div>
	        %s
	        ';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format author_disp
 * @return string html
 */
function keni_format_author_disp() {
	$title = __( 'Display Auther information', 'keni' ); // 投稿者情報の表示
	$main  = '%s';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format time_disp
 * @return string html
 */
function keni_format_time_disp() {
	$title = __( 'Display Date', 'keni' ); // 更新時間・投稿時間の表示
	$main  = '%s';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format single_after_contents
 * @return string html
 */
function keni_format_single_after_contents() {
	$title = __( 'Contents after Post', 'keni' ); // 記事下のコンテンツ
	$main  = '%s';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format relation
 * @return string html
 */
function keni_format_relation() {
	$title = __( 'Setting Relation Post for Site', 'keni' ); // 全体の関連記事設定
	$main  = '%s
	        <div style="padding-left: 2em;">
	        %s
	        %s
	        </div>
	        <p class="post-attributes-label-wrapper"><label class="post-attributes-label">' . __( '関連記事のスタイルの選択', 'keni' ) . '</label></p>
	        %s';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format thumbnail_disp
 * @return string html
 */
function keni_format_thumbnail_disp() {
	$title = __( 'Thumbnail for Single Post', 'keni' ); // 個別ページのアイキャッチ画像
	$main  = '%s';

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format toc_disp
 * @return string html
 */
function keni_format_toc_disp() {
	$ret_html = "";
	$title    = __( 'TOC Setting', 'keni' ); // 目次の設定
	$title1   = __( 'TOC Display Setting', 'keni' ); // 目次の表示
	$title2   = __( 'TOC Title', 'keni' ); // 目次のタイトル
	$title3   = __( 'TOC Display Depth', 'keni' ); // 目次のhタグカット最小数
	$title4   = __( 'TOC OPEN Setting', 'keni' ); // 目次の初期状態 close open
	$main     = "
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title1}</label></p>
			%s
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title2}</label></p>
	        %s
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title3}</label></p>
	        %s
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title4}</label></p>
	        %s
	        ";

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format toc_disp
 * @return string html
 */
function keni_format_home_name() {
	$ret_html = "";
	$title    = __( 'Breadcrumbs String Settings', 'keni' ); // パンくず 文字列設定
	$title1   = __( 'Breadcrumbs TOP Name', 'keni' ); // パンくず TOP サイト名
	$title2   = __( 'Breadcrumbs TOP String', 'keni' ); // パンくず TOP 文字列
	$main     = "
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title1}</label></p>
			%s
	        <p class='post-attributes-label-wrapper'><label class='post-attributes-label'>{$title2}</label></p>
	        %s
	        ";

	return keni_format_metabox_holder( $title, $main );
}

/**
 * Format Facebook Page Plugin
 * @return string   form html
 */
function keni_format_facebook_page_plugin() {

	$html = '<div class="facebook-pageplugin-area">%s</div>';

	return $html;
}

/**
 * keni_post_after Single after
 */
add_filter( 'keni_post_after', 'keni_output_single_after_contents' );
function keni_output_single_after_contents() {
	global $post;

	$output = '';
	if ( $post->post_type == 'post' ) {
		// 記事の下コンテンツ
		$str_get_single_after_contents = get_option( 'keni_single_after_contents' );
		if ( $str_get_single_after_contents != '' ) {
			$output = sprintf( keni_format_facebook_page_plugin(), $str_get_single_after_contents );
		}
	}

	echo $output;

}

/**
 * Author display
 * @return bool
 */
function keni_author_disp() {

	$bool                 = false;
	$flag_get_author_disp = get_option( 'keni_author_disp' );
	if ( $flag_get_author_disp == '1' ) {
		$bool = true;
	}
	$bool = apply_filters( 'keni_author_disp', $bool );

	return $bool;

}

//-----------------------------------------------------
// 著者情報のページ単位での表示
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_page_author_disp_post' );
add_action( 'save_post', 'keni_save_meta_box_page_author_disp_post' );

function keni_add_meta_box_page_author_disp_post() {
	$screen_array = apply_filters( 'keni_post_author_disp_posttype_list', array( 'post' ) );
	add_meta_box( 'post_author_disp', __( 'Display Auther information', 'keni' ), 'keni_insert_meta_box_post_author_disp', $screen_array, 'side', 'default' ); // ページタイトルの表示
}

function keni_insert_meta_box_post_author_disp() {

	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_post_author_disp_nonce' );

	// get setting
	$str_get_author_disp_post = get_post_meta( $post->ID, 'keni_author_disp_post', true );

	if ( empty( $str_get_author_disp_post ) ) {
		$str_get_author_disp_post = "";
	}

	$arr_list_author_disp_post = array(
		array( "", __( 'Use Default Setting', 'keni' ) ),
		array( "2", __( 'Display', 'keni' ) ),
		array( "1", __( 'Not Display', 'keni' ) )
	);

	echo keni_format_radio( 'keni_post_author_disp', $str_get_author_disp_post, $arr_list_author_disp_post );

}

function keni_save_meta_box_page_author_disp_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_post_author_disp_nonce'] ) ? $_POST['keni_meta_box_post_author_disp_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$str_get_post_author_disp = isset( $_POST['keni_post_author_disp'] ) ? $_POST['keni_post_author_disp'] : '';
	if ( ! empty( $str_get_post_author_disp ) ) {
		update_post_meta( $post_id, 'keni_author_disp_post', $str_get_post_author_disp );
	} else {
		delete_post_meta( $post_id, 'keni_author_disp_post' );
	}
}

/**
 * Author display postmeta
 */
function keni_author_disp_by_postid( $post_id = 0 ) {
	global $post;
	$bool = true;
	if ( $post_id === 0 ) {
		$post_id = $post->ID;
	}
	$flag_get_author_disp_post = get_post_meta( $post_id, 'keni_author_disp_post', true );

	if ( $flag_get_author_disp_post == '1' ) {      // 表示しない
		$bool = false;
	} elseif ( $flag_get_author_disp_post == '2' ) {    // 表示する
		$bool = true;
	} elseif ( $flag_get_author_disp_post == '' ) {    // 基本設定通り
		$bool = keni_author_disp();
	}
	$bool = apply_filters( 'keni_author_disp_post', $bool, $post_id );

	return $bool;
}

//-----------------------------------------------------
// 固定ページのページタイトル表示
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_page_title_disp_page' );
add_action( 'save_post', 'keni_save_meta_box_page_title_disp_page' );

function keni_add_meta_box_page_title_disp_page() {
	add_meta_box( 'page_title_disp', __( 'Display Page Title', 'keni' ), 'keni_insert_meta_box_page_title_disp_page', 'page', 'side', 'default' ); // ページタイトルの表示
}

function keni_insert_meta_box_page_title_disp_page() {

	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_page_title_disp_page_nonce' );

	// get setting
	$str_get_page_title_disp_page = get_post_meta( $post->ID, 'keni_page_title_disp_page', true );

	if ( empty( $str_get_page_title_disp_page ) ) {
		$str_get_page_title_disp_page = "";
	}

	$arr_list_page_title_disp = array(
		array( "", __( 'Display', 'keni' ) ),
		array( "1", __( 'Not Display', 'keni' ) ),
	);

	echo keni_format_radio( 'keni_page_title_disp_page', $str_get_page_title_disp_page, $arr_list_page_title_disp );

}

function keni_save_meta_box_page_title_disp_page( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_page_title_disp_page_nonce'] ) ? $_POST['keni_meta_box_page_title_disp_page_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$str_get_page_title_disp_page = isset( $_POST['keni_page_title_disp_page'] ) ? $_POST['keni_page_title_disp_page'] : '';
	if ( ! empty( $str_get_page_title_disp_page ) ) {
		update_post_meta( $post_id, 'keni_page_title_disp_page', $str_get_page_title_disp_page );
	} else {
		delete_post_meta( $post_id, 'keni_page_title_disp_page' );
	}
}

/**
 * 固定ページにタグを設定出来るようにする
 */
function add_tag_to_page() {
	register_taxonomy_for_object_type( 'post_tag', 'page' );
}

add_action( 'init', 'add_tag_to_page' );

/**
 * タグのアーカイブに 固定ページを含める
 *
 * @param $obj
 */
function add_page_to_tag_archive( $obj ) {
	if ( is_tag() && $obj->is_main_query() ) {
		$obj->query_vars['post_type'] = array( 'post', 'page' );
	}
}

add_action( 'pre_get_posts', 'add_page_to_tag_archive' );

//-----------------------------------------------------
// パンくず優先カテゴリ設定
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_primary_category_post' );
add_action( 'save_post', 'keni_save_meta_box_primary_category_post' );

// URL
add_filter( 'post_link_category', 'keni_post_link_category', 10, 3 );

function keni_add_meta_box_primary_category_post() {
	add_meta_box( 'primary_category_area', __( 'Setting of BreadcrumbList priority', 'keni' ), 'keni_insert_meta_box_primary_category_post', 'post', 'side', 'default' ); // パンくず優先カテゴリ設定
}

function keni_insert_meta_box_primary_category_post() {

	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_primary_category_post_nonce' );

	// get setting
	$str_get_primary_category_post = get_post_meta( $post->ID, 'keni_primary_category_post', true );
	// get my category
	$arr_my_category = get_the_category();

	if ( empty( $str_get_primary_category_post ) && ! empty( $arr_my_category[0] ) ) {
		$str_get_primary_category_post = $arr_my_category[0]->term_id;
	}

	$i                         = 0;
	$arr_list_primary_category = array();
	foreach ( $arr_my_category as $cat ) {
		$arr_list_primary_category[ $i ] = array( $cat->term_id, $cat->name );
		$i ++;
	}

	$permalink_structure_str = get_option( 'permalink_structure', '' );
	$permalink_caution       = "";
	if ( stripos( $permalink_structure_str, "%category%" ) !== false ) {
		$permalink_caution = "<div style=\"background: #f1f1f1;padding: 5px\">パーマリンクの設定に「%category%」を含む場合、優先カテゴリを設定することでURLが変更になる場合があります。<b>ご注意ください。</b></div>";
	}
	$remove_btn_html = "<button onclick=\"for (const element of document.getElementsByName('keni_primary_category_post')) {element.checked = false;}\">解除する</button>";
	echo keni_format_radio( 'keni_primary_category_post', $str_get_primary_category_post, $arr_list_primary_category ) . $remove_btn_html . $permalink_caution;
}

function keni_save_meta_box_primary_category_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_primary_category_post_nonce'] ) ? $_POST['keni_meta_box_primary_category_post_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$str_get_primary_category_post = isset( $_POST['keni_primary_category_post'] ) ? $_POST['keni_primary_category_post'] : '';
	if ( ! empty( $str_get_primary_category_post ) ) {
		update_post_meta( $post_id, 'keni_primary_category_post', $str_get_primary_category_post );
	} else {
		delete_post_meta( $post_id, 'keni_primary_category_post' );
	}
}

//-----------------------------------------------------
// 関連記事設定
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_relation_post' );
add_action( 'save_post', 'keni_save_meta_box_relation_post' );

function keni_add_meta_box_relation_post() {
	add_meta_box( 'relation', __( 'Setting of Relation Post', 'keni' ), 'keni_insert_meta_box_relation_post', array(
		'post',
		'page'
	), 'normal', 'high' ); // 関連記事設定
}

function keni_insert_meta_box_relation_post() {
	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_relation_post_nonce' );


	# set relation display
	$flag_get_relation_disp_post = get_post_meta( $post->ID, 'keni_relation_disp_post', true );
	$arr_list_relation_disp      = array(
		array( "", __( 'Use Default Setting', 'keni' ) ), // 全体の設定を適用する
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);

	// set category relation
	$flag_category_relation = get_post_meta( $post->ID, 'keni_category_relation_post', true );
	$flag_category_relation = apply_filters( 'keni_category_relation', $flag_category_relation );
	// 賢威 functions.php カスタマイズ
	if ( $flag_category_relation == 'y' ) {
		$flag_category_relation = "1";
	}
	$arr_list_category_relation = array(
		array( "1", __( 'Category', 'keni' ) ),
	);

	// set tag relation
	$flag_tag_relation = get_post_meta( $post->ID, 'keni_tag_relation_post', true );
	$flag_tag_relation = apply_filters( 'keni_tag_relation', $flag_tag_relation );
	// 賢威 functions.php カスタマイズ
	if ( $flag_tag_relation == 'y' ) {
		$flag_tag_relation = "1";
	}
	$arr_list_tag_relation = array(
		array( "1", __( 'Tag', 'keni' ) ),
	);

	// set relation lists
	$keni_related_post_count = apply_filters( 'keni_related_post_count', 6 );

	for ( $i = 0; $i < $keni_related_post_count; $i ++ ) {
		$arr_set_relation[ $i ]['title'] = "";
		$arr_set_relation[ $i ]['url']   = "";
		$arr_set_relation[ $i ]['blank'] = "";
	}

	if ( isset( $_GET['post'] ) ) {
		$arr_relation_post = get_post_meta( $post->ID, 'keni_relation_post', true );
		if ( ! empty( $arr_relation_post ) && is_array( $arr_relation_post ) ) {
			foreach ( $arr_relation_post as $key => $value ) {
				if ( ! empty( $value ) ) {
					$arr_set_relation[ $key ] = $value;
				}
			}
		}
	}

	// display relation
	$str_html_relation_disp_post     = keni_format_radio( 'keni_relation_disp_post', $flag_get_relation_disp_post, $arr_list_relation_disp );
	$str_html_category_relation_post = keni_format_checkbox( 'keni_category_relation_post', $flag_category_relation, $arr_list_category_relation, true );
	$str_html_tag_relation_post      = keni_format_checkbox( 'keni_tag_relation_post', $flag_tag_relation, $arr_list_tag_relation, true );
	$str_html_relation_lists         = keni_format_relation_lists( $arr_set_relation );

	if ( $post->post_type == 'post' ) {
		echo sprintf( keni_format_relation_post(), $str_html_relation_disp_post, $str_html_category_relation_post, $str_html_tag_relation_post, $str_html_relation_lists );
	} else if ( $post->post_type == 'page' ) {
		echo sprintf( keni_format_relation_page(), $str_html_relation_disp_post, $str_html_tag_relation_post, $str_html_relation_lists );
	}
}

function keni_save_meta_box_relation_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_relation_post_nonce'] ) ? $_POST['keni_meta_box_relation_post_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// get post
	$flag_get_relation_disp_post = isset( $_POST['keni_relation_disp_post'] ) ? $_POST['keni_relation_disp_post'] : '';
	$flag_category_relation_post = isset( $_POST['keni_category_relation_post'] ) ? $_POST['keni_category_relation_post'] : '';
	$flag_tag_relation_post      = isset( $_POST['keni_tag_relation_post'] ) ? $_POST['keni_tag_relation_post'] : '';
	$arr_relation_post           = isset( $_POST['keni_relation_post'] ) ? $_POST['keni_relation_post'] : '';

	// save relation display
	update_post_meta( $post_id, 'keni_relation_disp_post', $flag_get_relation_disp_post );

	// save category relation
	if ( $flag_get_relation_disp_post == '1' && empty( $flag_category_relation_post ) && empty( $flag_tag_relation_post ) && empty( $arr_relation_post ) ) {
		$flag_category_relation_post = '1';
	}
	if ( ! empty( $flag_category_relation_post ) ) {
		update_post_meta( $post_id, 'keni_category_relation_post', $flag_category_relation_post );
	} else {
		delete_post_meta( $post_id, 'keni_category_relation_post' );
	}

	// save tag relation
	if ( ! empty( $flag_tag_relation_post ) ) {
		update_post_meta( $post_id, 'keni_tag_relation_post', $flag_tag_relation_post );
	} else {
		delete_post_meta( $post_id, 'keni_tag_relation_post' );
	}

	// save relation lists
	if ( ! empty( $arr_relation_post ) && is_array( $arr_relation_post ) ) {
		$update_relation_data = array();
		foreach ( $arr_relation_post as $no => $val ) {
			if ( ! isset( $val['title'] ) ) {
				$val['title'] = "";
			}
			if ( ! isset( $val['blank'] ) ) {
				$val['blank'] = "";
			}
			if ( ! isset( $val['image'] ) ) {
				$val['image'] = "";
			}
			if ( $val['url'] != "" && ( ! isset( $arr_relation_post[ $no ]['image'] ) || ( $arr_relation_post[ $no ]['image'] == "" ) ) ) {
				$site_data = wp_remote_get( $val['url'] );

				if ( ! is_wp_error( $site_data ) && $site_data['response']['code'] === 200 && $site_data['body'] != "" ) {
					$content = $site_data['body'];

					preg_match_all( '/og:image.*?content="(http.*?[gif|jpg|jpeg|png])"/u', $content, $images );
					if ( ! isset( $images[1][0] ) ) {
						preg_match_all( '/itemprop.*?image.+?content="(http.+?[gif|jpg|jpeg|png])" \/>/u', $content, $images );
					}
					$val['image'] = ( isset( $images[1][0] ) && ! empty( $images[1][0] ) ) ? $images[1][0] : "";
				}
			}

			if ( $val['url'] != "" ) {
				$update_relation_data[] = $val;
			}
		}

		update_post_meta( $post_id, 'keni_relation_post', $update_relation_data );
	} else {
		delete_post_meta( $post_id, 'keni_relation_post' );
	}

}

/**
 * Format relation post form
 * @return string   form html
 */
function keni_format_relation_post() {
	$html = '
			%s
			<div style="padding-left: 2em;">
			<p>既に公開されている記事から、記事と同一の「カテゴリー」と「タグ」に含まれているものをランダムに表示する事が出来ます。<br />
			両方にチェックが入っている場合には、カテゴリが優先されます。</p>
			%s
			%s
			<p>「カテゴリー」「タグ」以外の任意のURLを設定することも可能です。（その場合、以下で設定したURLが優先的に表示されます。）<br />
			左から「記事タイトル」「記事URL」を入力して下さい。<br />リンクを新ウィンドウで開きたい場合は、右のチェックボックスにチェックを入れて下さい。</p>
			<p class="keni_note">ベーシック認証がされているURLは入力ができません</p>
			%s
			</div>';

	return $html;
}

/**
 * Format relation page form
 * @return string   form html
 */
function keni_format_relation_page() {
	$html = '
			%s
			<div style="padding-left: 2em;">
			<p>既に公開されている記事から、記事と同一の「タグ」に含まれているものをランダムに表示する事が出来ます。</p>
			%s
			<p>「タグ」以外の任意のURLを設定することも可能です。（その場合、以下で設定したURLが優先的に表示されます。）<br />
			左から「記事タイトル」「記事URL」を入力して下さい。<br />リンクを新ウィンドウで開きたい場合は、右のチェックボックスにチェックを入れて下さい。</p>
			%s
			</div>';

	return $html;
}


/**
 * Format relation lists
 * @return string   html
 */
function keni_format_relation_lists( $relation ) {
	$html = '<ol class="keni_relation_lists">' . "\n";

	foreach ( $relation as $no => $val ) {

		$str_html_relation_title_post = keni_format_text( 'keni_relation_post[' . $no . '][title]', $val["title"], 'keni_relation_title', __( 'Post Title', 'keni' ) ); // 記事タイトル
		$str_html_relation_url_post   = keni_format_text( 'keni_relation_post[' . $no . '][url]', $val["url"], 'keni_relation_url', __( 'Post URL', 'keni' ) ); // 記事URL
		$str_checked                  = ( $val['blank'] == "1" ) ? ' checked="checked"' : '';
		$str_html_relation_blank_post = '<input type="checkbox" name="keni_relation_post[' . $no . '][blank]" value="1"' . $str_checked . ' />';

		$html .= '<li>
				<span class="keni_relation_title">' . $str_html_relation_title_post . '</span>
				<span class="keni_relation_url">' . $str_html_relation_url_post . '</span>
				<span class="keni_relation_blank">' . $str_html_relation_blank_post . '</span>
				</li>';
	}

	$html .= "</ol>\n";

	return $html;
}


/**
 * 関連記事を表示する関数
 * @return string   html
 */
if ( ! function_exists( 'the_keni_relation' ) ) {
	function the_keni_relation() {
		echo get_keni_relation();
	}
}

if ( ! function_exists( 'get_keni_relation' ) ) {
	function get_keni_relation() {

	    // ノーイメージ画像
		$no_img_src = get_stylesheet_directory_uri() . '/images/no-image.jpg';
		$no_img_size                   = getimagesize( $no_img_src );
		$no_img_attr  = ( isset( $no_img_size[3] ) ? $no_img_size[3] : '' );

		$relation    = array();
		$str_li_list = "";
		global $post;
		$post_id = get_the_ID();

		// 関連記事数
		$keni_related_post_count = apply_filters( 'keni_related_post_count', 6 );
		$keni_related_post_count = apply_filters( 'keni_relation_link_count', $keni_related_post_count );   // 賢威7.1対応

		// 関連記事ソート
		$keni_related_post_orderby = apply_filters( 'keni_relation_link_orderby', 'rand' );
		// ソート順
		$keni_relation_link_order = apply_filters( 'keni_relation_link_order', 'DESC' );

		// 含める投稿タイプ（タグ）
		$keni_relation_link_post_type = apply_filters( 'keni_relation_link_post_type', array( 'post', 'page' ) );
		// 表示設定
		$flag_get_relation_disp      = get_option( 'keni_relation_disp' );
		$flag_get_relation_style     = get_option( 'keni_relation_style' );
		$flag_get_relation_disp_post = get_post_meta( get_the_ID(), 'keni_relation_disp_post', true );

		$category_relation = "";
		$tag_relation      = "";
		if ( $flag_get_relation_disp_post == "" ) {
			// 全体設定
			if ( $flag_get_relation_disp == "show" ) {
				$category_relation = get_option( 'keni_category_relation' );
				$tag_relation      = get_option( 'keni_tag_relation' );
			} else if ( $flag_get_relation_disp == "hide" ) {
				return;
			}
		} else if ( $flag_get_relation_disp_post == "show" ) {
			$category_relation = get_post_meta( get_the_ID(), 'keni_category_relation_post', true );
			$tag_relation      = get_post_meta( get_the_ID(), 'keni_tag_relation_post', true );
		} else if ( $flag_get_relation_disp_post == "hide" ) {
			return;
		}

		$keni_relation_disp_top = apply_filters( "keni_relation_disp_top", false );
		if ( ! is_home() && ! is_front_page() || ( ( is_home() || is_front_page() ) && $keni_relation_disp_top ) ) {
			$arr_relation_post = get_post_meta( get_the_ID(), 'keni_relation_post', true );
			if ( ! empty( $arr_relation_post ) && is_array( $arr_relation_post ) ) {
				foreach ( $arr_relation_post as $key => $relation_post ) {
					if ( count( $relation ) < $keni_related_post_count ) {

						$url = rawurldecode( $relation_post['url'] );

						$relation[ $url ]['title']  = $relation_post['title'];
						$relation[ $url ]['target'] = $relation_post['blank'];

						// 入力されたURLから記事IDが取得できる場合は、その投稿のアイキャッチ画像を設定する
						$this_post_id = url_to_postid( $relation_post['url'] );
						if ( ! empty( $this_post_id ) ) {
							if ( $relation_post['title'] == "" ) {
								// 記事情報取得
								$this_post_obj             = get_post( $this_post_id );
								$relation[ $url ]['title'] = $this_post_obj->post_title;
							}
							// アイキャッチ取得
							$image_id                   = get_post_thumbnail_id( $this_post_id );
							$image_url_data             = wp_get_attachment_image_src( $image_id, 'large_thumb' );
							$relation[ $url ]['image']  = ( isset( $image_url_data[0] ) ) ? $image_url_data[0] : '';
							$relation[ $url ]['width']  = ( isset( $image_url_data[1] ) ) ? $image_url_data[1] : '';
							$relation[ $url ]['height'] = ( isset( $image_url_data[2] ) ) ? $image_url_data[2] : '';

						} else {
							$relation[ $url ]['image']  = $relation_post['image'];
							$img_size                   = getimagesize( $relation_post['image'] );
							$relation[ $url ]['width']  = ( isset( $img_size[0] ) ? $img_size[0] : '' );
							$relation[ $url ]['height'] = ( isset( $img_size[1] ) ? $img_size[1] : '' );
						}
					}
				}
			}
		}


		if ( count( $relation ) < $keni_related_post_count ) {

			// カテゴリから取得する
			if ( $category_relation == "1" ) {

				// 優先カテゴリを取得し、その情報を取得
				$primary_cat_id = get_post_meta( get_the_ID(), 'keni_primary_category_post', true );
				if ( ! empty( $primary_cat_id ) ) {
					$tag_query  = array(
						'showposts'    => $keni_related_post_count,
						'cat'          => $primary_cat_id,
						'orderby'      => $keni_related_post_orderby,
						'order'        => $keni_relation_link_order,
						'post__not_in' => array( $post_id )
					);
					$tag_query  = apply_filters( 'keni_related_post_cat_query', $tag_query, $post_id );
					$rand_posts = new WP_Query( $tag_query );
					if ( $rand_posts->have_posts() ) {
						if ( $rand_posts->have_posts() ) {
							while ( $rand_posts->have_posts() ) {
								$rand_posts->the_post();
								if ( count( $relation ) < $keni_related_post_count ) {
									$url                        = rawurldecode( get_permalink( $post->ID ) );
									$relation[ $url ]['title']  = $post->post_title;
									$relation[ $url ]['target'] = '';

									$thumbnail_id              = get_post_thumbnail_id( $post->ID );
									$thumbnail                 = wp_get_attachment_image_src( $thumbnail_id, 'large_thumb' );
									$relation[ $url ]['image'] = isset( $thumbnail[0] ) ? $thumbnail[0] : '';
								}
							}
						}
					}
					wp_reset_query();
				}

				if ( count( $relation ) < $keni_related_post_count ) {
					$target_category = get_the_category( get_the_ID() );
					if ( isset( $target_category ) && is_array( $target_category ) && count( $target_category ) > 0 ) {
						foreach ( $target_category as $cat_val ) {
							if ( $cat_val->cat_ID != $primary_cat_id ) {
								$cat_list[] = $cat_val->cat_ID;
							}
						}
					}

					if ( isset( $cat_list ) && count( $cat_list ) > 0 ) {
						$tag_query  = array(
							'showposts'    => $keni_related_post_count,
							'cat'          => implode( ",", $cat_list ),
							'orderby'      => $keni_related_post_orderby,
							'order'        => $keni_relation_link_order,
							'post__not_in' => array( $post_id )
						);
						$tag_query  = apply_filters( 'keni_related_post_cat_second_query', $tag_query, $post_id );
						$rand_posts = new WP_Query( $tag_query );
						if ( $rand_posts->have_posts() ) {
							if ( $rand_posts->have_posts() ) {
								while ( $rand_posts->have_posts() ) {
									$rand_posts->the_post();
									if ( count( $relation ) < $keni_related_post_count ) {
										$url                        = rawurldecode( get_permalink( $post->ID ) );
										$relation[ $url ]['title']  = $post->post_title;
										$relation[ $url ]['target'] = '';

										$thumbnail_id              = get_post_thumbnail_id( $post->ID );
										$thumbnail                 = wp_get_attachment_image_src( $thumbnail_id, 'large_thumb' );
										$relation[ $url ]['image'] = isset( $thumbnail[0] ) ? $thumbnail[0] : '';
										$relation[ $url ]['width']  = isset( $thumbnail[1] ) ? $thumbnail[1] : '';
										$relation[ $url ]['height'] = isset( $thumbnail[2] ) ? $thumbnail[2] : '';

										$relation[ $url ] = apply_filters( 'keni_relation_cat_data', $relation[ $url ], get_the_ID() );
									}
								}
							}
						}
						wp_reset_query();
					}
				}
			}
		}

		if ( count( $relation ) < $keni_related_post_count ) {

			// タグから取得する
			if ( $tag_relation == "1" ) {
				$target_tags = get_the_tags();
				if ( isset( $target_tags ) && is_array( $target_tags ) && count( $target_tags ) > 0 ) {
					foreach ( $target_tags as $tag_val ) {
						$tag_list[] = $tag_val->term_id;
					}
				}

				if ( isset( $tag_list ) && count( $tag_list ) > 0 ) {
					$tag_query = array(
						'post_type'    => $keni_relation_link_post_type,
						'tag__in'      => $tag_list,
						'showposts'    => $keni_related_post_count,
						'orderby'      => $keni_related_post_orderby,
						'order'        => $keni_relation_link_order,
						'post__not_in' => array( $post_id )
					);
					$tag_query = apply_filters( 'keni_related_post_tag_query', $tag_query );
					$query     = new WP_Query( $tag_query );
					if ( $query->have_posts() ) : while ( $query->have_posts() ) : $query->the_post();
						if ( count( $relation ) < $keni_related_post_count ) {
							$url                        = rawurldecode( get_permalink( $post->ID ) );
							$relation[ $url ]['title']  = get_the_title();
							$relation[ $url ]['target'] = '';

							$thumbnail_id              = get_post_thumbnail_id( get_the_ID() );
							$thumbnail                 = wp_get_attachment_image_src( $thumbnail_id, 'large_thumb' );
							$relation[ $url ]['image'] = isset( $thumbnail[0] ) ? $thumbnail[0] : '';
						}
					endwhile;
					endif;
					wp_reset_query();
				}
			}
		}

		$str_relation_style = '';
		$str_img_width      = '';
		if ( $flag_get_relation_style == '1' ) {
			$str_relation_style = 'related-entry-list_style01';
			$str_img_width      = ' width="150"';
		} elseif ( $flag_get_relation_style == '2' ) {
			$str_relation_style = 'related-entry-list_style02';
		}

		if ( count( $relation ) > 0 ) {
			foreach ( $relation as $url => $val ) {

			    $str_img_attr = "";
				if ( $flag_get_relation_style == '2' ) {
					if ( ! empty( $val['width'] ) && ! empty( $val['height'] ) ) {
						$str_img_attr = ' width="' . $val['width'] . '" height="' . $val['height'] . '"';
					}
				}
				$str_image_url = ( $val['image'] != "" ? $val['image'] : $no_img_src );
				if ( $str_image_url == $no_img_src ) {
					$str_img_attr = $no_img_attr;
				}
				if ( ! empty( $str_img_attr ) ) {
				    // N/A
                } else {
				    $str_img_attr = $str_img_width;
                }
				$str_target = ( $val['target'] == "1" ) ? ' target="_blank"' : '';

				$str_html      = '<li class="related-entry-list_item"><figure class="related-entry_thumb"><a href="' . $url . '" title="' . esc_attr( $val['title'] ) . '"' . $str_target . '>';
				$str_html      .= '<img src="' . $str_image_url . '" class="relation-image"' . $str_img_attr . '>';
				$str_html      .= '</a></figure><p class="related-entry_title"><a href="' . $url . '" title="' . esc_attr( $val['title'] ) . '"' . $str_target . '>' . esc_attr( $val['title'] ) . '</a></p></li>';
				$str_li_list   .= apply_filters( 'keni_relation_li_list', $str_html, $url, $val, $str_image_url );

			}
		}

		if ( ! empty( $str_li_list ) ) {

			return sprintf( keni_format_related_template(), $str_relation_style, $str_li_list );

		}

	}
}

/**
 * format related template
 * @return string
 */
function keni_format_related_template() {

	return '<div class="keni-related-area keni-section_wrap keni-section_wrap_style02">
			<section class="keni-section">

			<h2 class="keni-related-title">' . __( 'Related Posts', 'keni' ) . '</h2>

			<ul class="related-entry-list %s">
			%s
			</ul>


			</section><!--keni-section-->
		</div>';
}

//-----------------------------------------------------
// この投稿だけの個別CSS／JS記述欄
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_add_script_post' );
add_action( 'save_post', 'keni_save_meta_box_add_script_post' );

function keni_add_meta_box_add_script_post() {
	add_meta_box( 'add_script', __( 'CSS/JS for this post', 'keni' ), 'keni_insert_meta_box_add_script_post', array(
		'post',
		'page'
	), 'normal', 'low' ); // この投稿だけの個別CSS／JS記述欄
}

function keni_insert_meta_box_add_script_post() {
	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_add_script_post_nonce' );

	// set add script
	$str_add_script_post = get_post_meta( $post->ID, 'keni_add_script_post', true );

	// display add script
	echo keni_format_textarea( 'keni_add_script_post', $str_add_script_post, 'large-text' );
}

function keni_save_meta_box_add_script_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_add_script_post_nonce'] ) ? $_POST['keni_meta_box_add_script_post_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$str_get_add_script_post = isset( $_POST['keni_add_script_post'] ) ? $_POST['keni_add_script_post'] : '';
	if ( ! empty( $str_get_add_script_post ) ) {
		update_post_meta( $post_id, 'keni_add_script_post', $str_get_add_script_post );
	} else {
		delete_post_meta( $post_id, 'keni_add_script_post' );
	}

}

/**
 * 個別のCSS/JS 追加
 * 最後に追加 999
 */
add_action( 'wp_footer', 'keni_output_add_script_post', 999 );
function keni_output_add_script_post() {
	remove_action( 'wp_head', 'wp_custom_css_cb', 101 );  // 追加CSSを最後に追加するため削除
	add_action( 'wp_enqueue_scripts', 'wp_custom_css_cb', 101 );    // WordPressの「追加CSS」をここで呼び出し


	$script_str = "";

	if ( is_singular() ) {
		global $post;
		$str_add_script_post = get_post_meta( $post->ID, 'keni_add_script_post', true );

		if ( ! empty( $str_add_script_post ) ) {
			$script_str .= $str_add_script_post . "\r\n";
		}

	}
	echo $script_str;
}

//-----------------------------------------------------
// アイキャッチ画像 個別設定
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_thumbnail_disp_post' );
add_action( 'save_post', 'keni_save_meta_box_thumbnail_disp_post' );

function keni_add_meta_box_thumbnail_disp_post() {
	add_meta_box( 'thumbnail_disp', __( 'Thumbnail for Single', 'keni' ), 'keni_insert_meta_box_thumbnail_disp_post', array(
		'post',
		'page'
	), 'side', 'default' );
}

function keni_insert_meta_box_thumbnail_disp_post() {

	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_thumbnail_disp_post_nonce' );

	// get setting
	$flag_get_thumbnail_disp_post = get_post_meta( $post->ID, 'keni_thumbnail_disp_post', true );

	if ( empty( $flag_get_thumbnail_disp_post ) ) {
		$flag_get_thumbnail_disp_post = "";
	}

	$arr_list_thumbnail_disp_post = array(
		array( "", __( 'Use Default Setting', 'keni' ) ),
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);

	echo keni_format_radio( 'keni_thumbnail_disp_post', $flag_get_thumbnail_disp_post, $arr_list_thumbnail_disp_post );

}

function keni_save_meta_box_thumbnail_disp_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_thumbnail_disp_post_nonce'] ) ? $_POST['keni_meta_box_thumbnail_disp_post_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$flag_get_thumbnail_disp_post = isset( $_POST['keni_thumbnail_disp_post'] ) ? $_POST['keni_thumbnail_disp_post'] : '';
	if ( ! empty( $flag_get_thumbnail_disp_post ) ) {
		update_post_meta( $post_id, 'keni_thumbnail_disp_post', $flag_get_thumbnail_disp_post );
	} else {
		delete_post_meta( $post_id, 'keni_thumbnail_disp_post' );
	}
}


/**
 * 個別ページのアイキャッチ画像表示設定取得
 * @return bool
 */
if ( ! function_exists( 'keni_is_thumbnail' ) ) {

	function keni_is_thumbnail() {
		global $post;

		$bool = true;

		$flag_get_thumbnail_disp_post = get_post_meta( $post->ID, 'keni_thumbnail_disp_post', true );

		if ( $flag_get_thumbnail_disp_post == "hide" ) {

			$bool = false;

		} else if ( empty( $flag_get_thumbnail_disp_post ) ) {

			$flag_get_thumbnail_disp = get_option( 'keni_thumbnail_disp' );

			if ( $flag_get_thumbnail_disp == "hide" ) {

				$bool = false;

			}
		}

		return $bool;

	}
}


//-----------------------------------------------------
// 目次 個別設定
//-----------------------------------------------------
add_action( 'admin_menu', 'keni_add_meta_box_toc_disp_post' );
add_action( 'save_post', 'keni_save_meta_box_toc_disp_post' );

function keni_add_meta_box_toc_disp_post() {
	add_meta_box( 'toc_disp', __( 'TOC Display Setting', 'keni' ), 'keni_insert_meta_box_toc_disp_post', array(
		'post',
		'page'
	), 'side', 'default' );
}

function keni_insert_meta_box_toc_disp_post() {

	global $post;
	wp_nonce_field( wp_create_nonce( __FILE__ ), 'keni_meta_box_toc_disp_post_nonce' );

	// get setting
	$flag_get_toc_disp_post = get_post_meta( $post->ID, 'keni_toc_disp_post', true );

	if ( empty( $flag_get_toc_disp_post ) ) {
		$flag_get_toc_disp_post = "";
	}

	$arr_list_toc_disp_post = array(
		array( "", __( 'Use Default Setting', 'keni' ) ),
		array( "hide", __( 'Not Display', 'keni' ) ),
		array( "show", __( 'Display', 'keni' ) ),
	);

	echo keni_format_radio( 'keni_toc_disp_post', $flag_get_toc_disp_post, $arr_list_toc_disp_post );

}

function keni_save_meta_box_toc_disp_post( $post_id ) {
	$str_nonce = isset( $_POST['keni_meta_box_toc_disp_post_nonce'] ) ? $_POST['keni_meta_box_toc_disp_post_nonce'] : null;

	if ( ! wp_verify_nonce( $str_nonce, wp_create_nonce( __FILE__ ) ) ) {
		return $post_id;
	}
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
		return $post_id;
	}
	if ( ! current_user_can( 'edit_post', $post_id ) ) {
		return $post_id;
	}

	// save
	$flag_get_toc_disp_post = isset( $_POST['keni_toc_disp_post'] ) ? $_POST['keni_toc_disp_post'] : '';
	if ( ! empty( $flag_get_toc_disp_post ) ) {
		update_post_meta( $post_id, 'keni_toc_disp_post', $flag_get_toc_disp_post );
	} else {
		delete_post_meta( $post_id, 'keni_toc_disp_post' );
	}
}


/**
 * 個別ページのアイキャッチ画像表示設定取得
 * 初期設定は非表示
 * @return bool
 */
if ( ! function_exists( 'keni_is_toc' ) ) {

	function keni_is_toc() {
		global $post;

		$bool = false;
		if ( ! is_singular() ) {
			return $bool;
		}

		$flag_get_toc_disp_post = get_post_meta( $post->ID, 'keni_toc_disp_post', true );

		if ( $flag_get_toc_disp_post == "show" ) {

			$bool = true;

		} else if ( empty( $flag_get_toc_disp_post ) ) {

			$flag_get_toc_disp = get_option( 'keni_toc_disp' );
			if ( $flag_get_toc_disp == "show" ) {
				$bool = true;
			}
		}

		return $bool;
	}
}

/**
 * 保護中記事のパスワードフォーム前にコンテンツを表示
 * <!--more--> まで
 *
 * @param $content_str
 *
 * @return string
 */
if ( ! function_exists( 'keni_password_form' ) ) {
	function keni_password_form( $content_str = "" ) {
		global $post;
		if ( ! strpos( $post->post_content, '<!--more-->' ) ) {
			return $content_str;
		}

		$content = explode( '<!--more-->', $post->post_content );

		return $content[0] . $content_str;
	}

}

/**
 * パスワード保護記事のタイトルで <!--more--> がある場合は 保護中: を付けない
 *
 * @param $title
 *
 * @return string
 */
if ( ! function_exists( 'keni_password_title_format' ) ) {
	function keni_password_title_format( $title ) {
		global $post;

		if ( isset( $post->post_content ) && ! strpos( $post->post_content, '<!--more-->' ) ) {
			return $title;
		}

		return '%s';
	}
}


/**
 * テキスト整形を無効化
 * 利用時は functions.php 等に
 * add_filter( 'init', 'keni_remove_format' );
 * を記述する
 * keni_remove_format
 */
if ( ! function_exists( 'keni_remove_format' ) ) {
	function keni_remove_format() {
		$wpautop_flg = apply_filters( 'keni_remove_wpautop', true );
		if ( $wpautop_flg === true ) {
			remove_filter( 'the_content', 'wpautop', 10 );
		}
		$wptexturize_flg = apply_filters( 'keni_remove_wptexturize', true );
		if ( $wptexturize_flg === true ) {
			remove_filter( 'the_content', 'wptexturize', 10 );
		}
		$widget_wpautop_flg = apply_filters( 'keni_remove_widget_wpautop', true );
		if ( $widget_wpautop_flg === true ) {
			remove_filter( 'widget_text_content', 'wpautop', 10 );
		}
		$widget_wptexturize_flg = apply_filters( 'keni_remove_widget_wptexturize', true );
		if ( $widget_wptexturize_flg === true ) {
			remove_filter( 'widget_text_content', 'wptexturize', 10 );
		}

		$mce_options_flg = apply_filters( 'keni_mce_options', true );
		if ( $mce_options_flg === true ) {
			add_filter( 'tiny_mce_before_init', 'keni_override_mce_options' );
		}
	}
}

/**
 * noreferrer 除去設定
 * keni_remove_format
 */
if ( ! function_exists( 'keni_remove_noreferrer' ) ) {
	function keni_remove_noreferrer() {
		//エディターでrel="noopener noreferrer"自動付加の解除
		add_filter( 'tiny_mce_before_init', 'keni_tinymce_allow_unsafe_link_target' );
		function keni_tinymce_allow_unsafe_link_target( $mce_init ) {
			$mce_init['allow_unsafe_link_target'] = true;

			return $mce_init;
		}

		// WordPressによって付与される noreferrer の削除
		add_filter( 'wp_targeted_link_rel', 'keni_wp_targeted_link_rel_custom', 10, 2 );
		function keni_wp_targeted_link_rel_custom( $ret_str, $link_html ) {
			$ret_str = str_replace( ' noreferrer', '', $ret_str );

			return $ret_str;
		}
	}
}

/**
 * keni_override_mce_options
 *
 * @param $init_array
 *
 * @return mixed
 */
if ( ! function_exists( 'keni_override_mce_options' ) ) {
	function keni_override_mce_options( $init_array ) {
		global $allowedposttags;
//		$init_array['valid_elements']          = '*[*]';
//		$init_array['extended_valid_elements'] = '*[*]';
//		$init_array['valid_children']          = '+a[' . implode( '|', array_keys( $allowedposttags ) ) . ']';
		$init_array['indent']           = true;
		$init_array['wpautop']          = false;
		$init_array['force_p_newlines'] = false;
		$init_array                     = apply_filters( 'keni_override_mce_options', $init_array );

		return $init_array;
	}
}

/**
 * 投稿タイプに応じたテンプレートファイルを取得する
 *
 * @return false|string
 */
if ( ! function_exists( 'keni_get_template_post_type' ) ) {
	function keni_get_template_post_type() {
		$template_post_type = "post";
		if ( locate_template( 'template-parts/content-' . get_post_type() . '.php' ) ) {
			$template_post_type = get_post_type();
		}
		$template_post_type = apply_filters( 'keni_get_template_post_type', $template_post_type );

		return $template_post_type;
	}
}


/**
 * 最新情報リスト
 *
 * @param string $target
 * @param int $num_of_posts
 * @param int $excerpt
 * @param string $show_date
 * @param int $catid
 * @param string $show_cat
 *
 * @return string
 */
if ( ! function_exists( 'newposts_keni' ) ) {
	function newposts_keni( $target = "new", $num_of_posts = 5, $excerpt = 1, $show_date = "default", $catid = 0, $show_cat = "true" ) {

		$res_data = posts_list_keni( $target, $num_of_posts, $excerpt, $show_date, "category", $catid, $show_cat, "" );

		return $res_data;
	}
}

/**
 * 記事一覧表示
 *
 * @param string $target
 * @param int $num_of_posts
 * @param int $excerpt
 * @param string $show_date
 * @param string $kind
 * @param int $var_id
 * @param string $show_tag
 * @param string $title_str
 *
 * @return string
 */
if ( ! function_exists( 'posts_list_keni' ) ) {
	function posts_list_keni( $target = "new", $num_of_posts = 5, $excerpt = 1, $show_date = "default", $kind = "category", $var_id = 0, $show_tag = "true", $title_str = "", $ex_cat = "" ) {

		$show_pv = apply_filters( 'keni_posts_list_show_pv', '' );

		wp_reset_query();

		// HTML格納変数
		$res_data = "\n\n";

		// カテゴリー除外IDを取得
		$ex       = apply_filters( 'posts_list_keni_ex_cat', $ex_cat );    // ver.7 では the_keni('new_info_ex_cat') で除外していた
		$ex_array = explode( ",", $ex );
		foreach ( $ex_array as $ex_id ) {
			if ( is_numeric( $ex_id ) ) {
				$ex_ids[] = $ex_id;
			}
		}

		// 検索条件
		$cond_array                        = array();
		$cond_array['posts_per_page']      = $num_of_posts;
		$cond_array['nopaging']            = 0;
		$cond_array['post_status']         = 'publish';
		$cond_array['ignore_sticky_posts'] = 1;

		// targetにより切り分け
		if ( $target == "new" ) {
			$res_data .= "<h2>" . ( $title_str != "" ? $title_str : __( 'Latest Info', 'keni' ) ) . "</h2>\n";
		} else {
			$res_data                          .= "<h2>" . ( $title_str != "" ? $title_str : __( 'Your blog&#8217;s WordPress Pages', 'keni' ) ) . "</h2>\n";
			$sticky                            = get_option( 'sticky_posts' );
			$cond_array['ignore_sticky_posts'] = 1;
			$cond_array['post__in']            = $sticky;
		}
		if ( ! is_array( $var_id ) && strpos( $var_id, "," ) > 0 ) {
			$var_id = explode( ",", $var_id );
		}
		switch ( $kind ) {
			case "tag":
				if ( ! is_array( $var_id ) ) {
					if ( is_numeric( $var_id ) ) {
						$cond_array['tag_id'] = $var_id;
					} else {
						$cond_array['tag'] = $var_id;
					}
				} else {
					if ( is_numeric( $var_id[0] ) ) {
						$cond_array['tag__in'] = $var_id;
					} else {
						$cond_array['tag_slug__in'] = $var_id;
					}
				}
				break;
			case "author":
				if ( ! is_array( $var_id ) ) {
					$cond_array['author'] = $var_id;
				} else {
					$cond_array['author__in'] = $var_id;
				}
				break;
			case "category":
			default:
				$cond_array['cat'] = $var_id;
				if ( isset( $ex_ids ) && is_array( $ex_ids ) && count( $ex_ids ) > 0 ) {
					$cond_array['category__not_in'] = $ex_ids;
				}
		}

		ob_start();

		if ( ! empty( $cond_array ) && count( $cond_array ) > 0 ) {
			$r = new WP_Query( $cond_array );
			if ( $r->have_posts() ) {
//				echo '<div class="keni-section_wrap keni-section_wrap_style02">';
//				echo '<div class="keni-section">';
//				echo '<div class="entry-list ' . get_keni_layout_post_list_class() . '">';
				while ( $r->have_posts() ) {
					$r->the_post();
					get_template_part( 'template-parts/content', 'archive' );
				}
//				echo '</div></div></div>';
			}
		}
		$post_list_echo = ob_get_contents();
		ob_end_clean();

		$post_list_echo = str_replace( "<h2 ", "<h3 ", $post_list_echo );
		$post_list_echo = str_replace( "/h2>", "/h3>", $post_list_echo );

		$res_data .= $post_list_echo;

		wp_reset_query();

		return $res_data;
	}
}

// エディタボタン追加
add_action( 'admin_print_footer_scripts', 'add_keni_quicktags' );

/**
 *    エディタにボタンを追加
 */
if ( ! function_exists( 'add_keni_quicktags' ) ) {
	function add_keni_quicktags() {
		if ( wp_script_is( 'quicktags' ) ) {

			// 機能OFFリスト （リストに含まれるものは除外）
			$off_list = apply_filters( 'keni_delete_quiucktags', array(
				// 'wide',
				// 'normal',
				// 'br',
				// 'hr',
				// 'h2',
				// 'h3',
				// 'h4',
				// 'h5',
				// 'black',
				// 'red',
				// 'orange',
				// 'green',
				// 'blue',
				// 'f12em',
				// 'f14em',
				// 'f16em',
				// 'f18em',
				// 'f20em',
				// 'al-l',
				// 'al-r',
				// 'al-c',
				// 'm60-t',
				// 'm60-b',
				// 'm120-t',
				// 'm120-b',
				// 'blockquote',
				// 'char',
				// 'cc',
				// 'add',
			) );
			// $off_list 精査
			if ( empty( $off_list ) || ! is_array( $off_list ) ) {
				$off_list = array();
			}

			$buttons = array();

			// 装飾用タグ
			if ( ! in_array( 'br', $off_list ) ) {
				$buttons['br'] = array( '改行（br）', '[br num=\"1\"]', '', '', 'br', '' );
			}
			if ( ! in_array( 'hr', $off_list ) ) {
				$buttons['hr'] = array( '水平線（hr）', '<hr>', '', '', 'hr', '' );
			}
			if ( ! in_array( 'h2', $off_list ) ) {
				$buttons['h2'] = array( '見出し（h2）', '<h2>', '</h2>', '', 'h2', '' );
			}
			if ( ! in_array( 'h3', $off_list ) ) {
				$buttons['h3'] = array( '見出し（h3）', '<h3>', '</h3>', '', 'h3', '' );
			}
			if ( ! in_array( 'h4', $off_list ) ) {
				$buttons['h4'] = array( '見出し（h4）', '<h4>', '</h4>', '', 'h4', '' );
			}
			if ( ! in_array( 'h5', $off_list ) ) {
				$buttons['h5'] = array( '見出し（h5）', '<h5>', '</h5>', '', 'h5', '' );
			}
			if ( ! in_array( 'black', $off_list ) ) {
				$buttons['black'] = array( '太字（黒）', '<span class=\"black b\">', '</span>', '', 'black', '' );
			}
			if ( ! in_array( 'red', $off_list ) ) {
				$buttons['red'] = array( '太字（赤）', '<span class=\"red b\">', '</span>', '', 'red', '' );
			}
			if ( ! in_array( 'orange', $off_list ) ) {
				$buttons['orange'] = array( '太字（オレンジ）', '<span class=\"orange b\">', '</span>', '', 'orange', '' );
			}
			if ( ! in_array( 'green', $off_list ) ) {
				$buttons['green'] = array( '太字（緑）', '<span class=\"green b\">', '</span>', '', 'green', '' );
			}
			if ( ! in_array( 'blue', $off_list ) ) {
				$buttons['blue'] = array( '太字（青）', '<span class=\"blue b\">', '</span>', '', 'blue', '' );
			}
			if ( ! in_array( 'f12em', $off_list ) ) {
				$buttons['f12em'] = array( '文字1.2倍', '<span class=\"f12em\">', '</span>', '', 'f12em', '' );
			}
			if ( ! in_array( 'f14em', $off_list ) ) {
				$buttons['f14em'] = array( '文字1.4倍', '<span class=\"f14em\">', '</span>', '', 'f14em', '' );
			}
			if ( ! in_array( 'f16em', $off_list ) ) {
				$buttons['f16em'] = array( '文字1.6倍', '<span class=\"f16em\">', '</span>', '', 'f16em', '' );
			}
			if ( ! in_array( 'f18em', $off_list ) ) {
				$buttons['f18em'] = array( '文字1.8倍', '<span class=\"f18em\">', '</span>', '', 'f18em', '' );
			}
			if ( ! in_array( 'f20em', $off_list ) ) {
				$buttons['f20em'] = array( '文字2倍', '<span class=\"f20em\">', '</span>', '', 'f20em', '' );
			}
			if ( ! in_array( 'al-l', $off_list ) ) {
				$buttons['al-l'] = array( '左寄せ', '<div class=\"al-l\">', '</div>', '', 'al-l', '' );
			}
			if ( ! in_array( 'al-r', $off_list ) ) {
				$buttons['al-r'] = array( '右寄せ', '<div class=\"al-r\">', '</div>', '', 'al-r', '' );
			}
			if ( ! in_array( 'al-c', $off_list ) ) {
				$buttons['al-c'] = array( '中央寄せ', '<div class=\"al-c\">', '</div>', '', 'al-c', '' );
			}
			if ( ! in_array( 'm60-t', $off_list ) ) {
				$buttons['m60-t'] = array( '余白（上60px）', '<div class=\"m60-t\">', '</div>', '', 'm60-t', '' );
			}
			if ( ! in_array( 'm60-b', $off_list ) ) {
				$buttons['m60-b'] = array( '余白（下60px）', '<div class=\"m60-b\">', '</div>', '', 'm60-b', '' );
			}
			if ( ! in_array( 'm120-t', $off_list ) ) {
				$buttons['m120-t'] = array( '余白（上120px）', '<div class=\"m120-t\">', '</div>', '', 'm120-t', '' );
			}
			if ( ! in_array( 'm120-b', $off_list ) ) {
				$buttons['m120-b'] = array( '余白（下120px）', '<div class=\"m120-b\">', '</div>', '', 'm120-b', '' );
			}
			if ( ! in_array( 'blockquote', $off_list ) ) {
				$buttons['blockquote'] = array(
					'引用セット',
					'<blockquote>\\n<p>ここに引用文が入ります。</p>\\n<p class=\"link-ref\"><cite>引用元: <a href=\"\" target=\"_blank\">参照記事のタイトル</a></cite></p>\\n</blockquote>',
					'',
					'',
					'blockquote',
					''
				);
			}

			$button = "";
			foreach ( $buttons as $key => $val_array ) {
				$button .= "QTags.addButton( '" . $key . "','" . $val_array[0] . "','" . $val_array[1] . "','" . $val_array[2] . "','" . $val_array[3] . "','" . $val_array[4] . "','" . $val_array[5] . "');\n";
			}
			if ( ! in_array( 'add', $off_list ) ) {
				$button = apply_filters( 'keni_add_quicktags', $button );
			}
			if ( $button != "" ) {
				echo "<script>\n" . $button . "</script>\n";
			}
		}
	}
}

function keni_post_link_category( $default, $cats, $post ) {
	$permalink_cat = keni_permalink_meta( $post->ID );
	if ( ! isset( $permalink_cat['category'] ) ) {
		return $default;
	}
	// 優先カテゴリをURLにするか
	if ( "1" != get_option( 'keni_permalink_cat_primary_off_flg', "0" ) &&
	     ( ! defined( 'KENI_PERMALINK_CAT_PRIMARY' ) || KENI_PERMALINK_CAT_PRIMARY != 'no' ) ) {
		// Find the category object for this
		foreach ( $cats as $cat ) {
			if ( $cat->term_id == $permalink_cat['category'] ) {
				return $cat;
			}
		}
	}

	return $default;
}

/**
 * 優先カテゴリーによるパーマリンク設定
 *
 * @param $post_id
 *
 * @return array|mixed
 */
function keni_permalink_meta( $post_id ) {
	$permalink_meta = get_post_meta( $post_id, 'keni_primary_category_post', true );

	if ( empty( $permalink_meta ) ) {
		return array();
	}

	// Old version -> integer, new version -> array
	if ( ! is_array( $permalink_meta ) ) {
		$permalink_meta = array( 'category' => $permalink_meta );
	}

	return $permalink_meta;
}

/**
 * 更新日時の変更を行う
 */
function keni_post_update_adjust() {
	// 投稿・固定以外にも更新方法の変更を設定できる
	$post_update_adjust_post_types = apply_filters( 'keni_post_update_adjust_post_type', array( 'post', 'page' ) );
	add_meta_box( 'keni_update_adjust', '更新日時設定', 'keni_post_update_adjust_box', $post_update_adjust_post_types, 'side', 'default' );
}

add_action( 'admin_menu', 'keni_post_update_adjust' );

/**
 * 更新方法変更ボックス
 */
function keni_post_update_adjust_box() {
	global $post;
	?>
    <ul>
        <li><label><input name="keni_update_adjust" type="radio" value="high" checked="checked">
                通常更新</label></li>
        <li><label><input name="keni_update_adjust" type="radio"
                          value="low">修正のみ(更新日時を変更せず記事更新)</label></li>
        <li><label><input name="keni_update_adjust" type="radio"
                          value="del"/>更新日時消去(公開日時と同じにする)</label></li>
        <li><label><input id="keni_update_adjust_edit" name="keni_update_adjust"
                          type="radio" value="edit"/>更新日時を手動で変更</label></li>
    </ul>
	<?php
	if ( get_the_modified_date( 'c' ) ) {
		$stamp = get_the_modified_date( __( 'M j, Y @ H:i' ) );
	} else {
		$stamp = '未更新';
	}
	$date = date_i18n( get_option( 'date_format' ) . ' @ ' . get_option( 'time_format' ), strtotime( $post->post_modified ) );
	?>
    <style>
        .keni_modtime {
            padding: 2px 0 1px 0;
            display: inline !important;
            height: auto !important;
        }

        .keni_modtime:before {
            font: normal 20px/1 'dashicons';
            content: '\f145';
            color: #888;
            padding: 0 5px 0 0;
            top: -1px;
            left: -1px;
            position: relative;
            vertical-align: top;
        }

        #keni_timestamp_adj {
            padding-top: 5px;
            line-height: 23px;
        }

        #keni_timestamp_adj p {
            margin: 8px 0 6px;
        }

        #keni_timestamp_adj input {
            border-width: 1px;
            border-style: solid;
        }

        #keni_timestamp_adj select {
            height: 21px;
            line-height: 14px;
            padding: 0;
            vertical-align: top;
            font-size: 12px;
        }

        #date_yy, #date_dd, #date_H, #date_i {
            padding: 1px;
            font-size: 12px;
        }

        #date_dd, #date_H, #date_i {
            width: 2em;
        }

        #date_yy {
            width: 3.4em;
        }
    </style>
    <span class="keni_modtime">更新日時: <span style="font-weight:bold"><?php printf( $stamp, $date ); ?></span></span>
    <div id="keni_timestamp_adj" onkeydown="document.getElementById('keni_update_adjust_edit').checked=true"
         onclick="document.getElementById('keni_update_adjust_edit').checked=true">
		<?php keni_time_mod_form(); ?>
    </div>
	<?php
}

/**
 * 更新日時変更フォーム表示
 */
function keni_time_mod_form() {
	global $wp_locale;
	global $post;

	$tab_index           = 0;
	$tab_index_attribute = '';
	if ( (int) $tab_index > 0 ) {
		$tab_index_attribute = ' tabindex="' . $tab_index . '"';
	}

	$date_dd = mysql2date( 'd', $post->post_modified, false );
	$date_mm = mysql2date( 'm', $post->post_modified, false );
	$date_yy = mysql2date( 'Y', $post->post_modified, false );
	$date_H  = mysql2date( 'H', $post->post_modified, false );
	$date_i  = mysql2date( 'i', $post->post_modified, false );
	$date_s  = mysql2date( 's', $post->post_modified, false );

	$year = '<label for="date_yy" class="screen-reader-text">年' .
	        '</label><input type="text" id="date_yy" name="date_yy" value="' .
	        $date_yy . '" size="4" maxlength="4"' . $tab_index_attribute . ' autocomplete="off" />年';

	$month = '<label for="date_mm" class="screen-reader-text">月' .
	         '</label><select id="date_mm" name="date_mm"' . $tab_index_attribute . ">\n";
	for ( $i = 1; $i < 13; $i = $i + 1 ) {
		$monthnum = zeroise( $i, 2 );
		$month    .= "\t\t\t" . '<option value="' . $monthnum . '" ' . selected( $monthnum, $date_mm, false ) . '>';
		$month    .= $wp_locale->get_month_abbrev( $wp_locale->get_month( $i ) );
		$month    .= "</option>\n";
	}
	$month .= '</select>';

	$day    = '<label for="date_dd" class="screen-reader-text">日' .
	          '</label><input type="text" id="date_dd" name="date_dd" value="' .
	          $date_dd . '" size="2" maxlength="2"' . $tab_index_attribute . ' autocomplete="off" />日';
	$hour   = '<label for="date_H" class="screen-reader-text">時' .
	          '</label><input type="text" id="date_H" name="date_H" value="' . $date_H .
	          '" size="2" maxlength="2"' . $tab_index_attribute . ' autocomplete="off" />';
	$minute = '<label for="date_i" class="screen-reader-text">分' .
	          '</label><input type="text" id="date_i" name="date_i" value="' . $date_i .
	          '" size="2" maxlength="2"' . $tab_index_attribute . ' autocomplete="off" />';

	printf( '%1$s %2$s %3$s @ %4$s : %5$s', $year, $month, $day, $hour, $minute );
	echo '<input type="hidden" id="date_s" name="date_s" value="' . $date_s . '" />';
}

/**
 * 修正のみ: 更新なし
 */
function keni_insert_post_data( $data, $postarr ) {
	$mydata = isset( $_POST['keni_update_adjust'] ) ? $_POST['keni_update_adjust'] : null;

	if ( $mydata === 'low' ) {
		unset( $data['post_modified'] );
		unset( $data['post_modified_gmt'] );
	} elseif ( $mydata === 'edit' ) {
		$date_yy       = $_POST['date_yy'] <= 0 ? date( 'Y' ) : $_POST['date_yy'];
		$date_mm       = $_POST['date_mm'] <= 0 ? date( 'n' ) : $_POST['date_mm'];
		$date_dd       = $_POST['date_dd'] > 31 ? 31 : $_POST['date_dd'];
		$date_dd       = $date_dd <= 0 ? date( 'j' ) : $date_dd;
		$date_H        = $_POST['date_H'] > 23 ? $_POST['date_H'] - 24 : $_POST['date_H'];
		$date_i        = $_POST['date_i'] > 59 ? $_POST['date_i'] - 60 : $_POST['date_i'];
		$date_s        = $_POST['date_s'] > 59 ? $_POST['date_s'] - 60 : $_POST['date_s'];
		$modified_date = sprintf( '%04d-%02d-%02d %02d:%02d:%02d', $date_yy, $date_mm, $date_dd, $date_H, $date_i, $date_s );
		if ( ! wp_checkdate( $date_mm, $date_dd, $date_yy, $modified_date ) ) {
			unset( $data['post_modified'] );
			unset( $data['post_modified_gmt'] );

			return $data;
		}
		$data['post_modified']     = $modified_date;
		$data['post_modified_gmt'] = get_gmt_from_date( $modified_date );
	} elseif ( $mydata === 'del' ) {
		$data['post_modified'] = $data['post_date'];
	}

	return $data;
}

add_filter( 'wp_insert_post_data', 'keni_insert_post_data', 10, 2 );
